import 'package:domain/generated/json/base/json_convert_content.dart';
import 'package:domain/entity/service_order_detail_entity.dart';
import 'package:domain/entity/id_name_entity.dart';


ServiceOrderDetailEntity $ServiceOrderDetailEntityFromJson(
    Map<String, dynamic> json) {
  final ServiceOrderDetailEntity serviceOrderDetailEntity = ServiceOrderDetailEntity();
  final String? id = jsonConvert.convert<String>(json['id']);
  if (id != null) {
    serviceOrderDetailEntity.id = id;
  }
  final String? sn = jsonConvert.convert<String>(json['sn']);
  if (sn != null) {
    serviceOrderDetailEntity.sn = sn;
  }
  final String? totalAmount = jsonConvert.convert<String>(json['total_amount']);
  if (totalAmount != null) {
    serviceOrderDetailEntity.totalAmount = totalAmount;
  }
  final String? paidAt = jsonConvert.convert<String>(json['paid_at']);
  if (paidAt != null) {
    serviceOrderDetailEntity.paidAt = paidAt;
  }
  final String? notes = jsonConvert.convert<String>(json['notes']);
  if (notes != null) {
    serviceOrderDetailEntity.notes = notes;
  }
  final ServiceOrderDetailAccount? account = jsonConvert.convert<
      ServiceOrderDetailAccount>(json['account']);
  if (account != null) {
    serviceOrderDetailEntity.account = account;
  }
  final ServiceOrderDetailOrderService? orderService = jsonConvert.convert<
      ServiceOrderDetailOrderService>(json['order_service']);
  if (orderService != null) {
    serviceOrderDetailEntity.orderService = orderService;
  }
  final IdNameEntity? merchant = jsonConvert.convert<IdNameEntity>(
      json['merchant']);
  if (merchant != null) {
    serviceOrderDetailEntity.merchant = merchant;
  }
  final List<
      ServiceOrderDetailOrderProducts>? orderProducts = (json['order_products'] as List<
      dynamic>?)?.map(
          (e) =>
      jsonConvert.convert<ServiceOrderDetailOrderProducts>(
          e) as ServiceOrderDetailOrderProducts).toList();
  if (orderProducts != null) {
    serviceOrderDetailEntity.orderProducts = orderProducts;
  }
  final ServiceOrderDetailEstate? estate = jsonConvert.convert<
      ServiceOrderDetailEstate>(json['estate']);
  if (estate != null) {
    serviceOrderDetailEntity.estate = estate;
  }
  final ServiceOrderDetailEstateUnit? estateUnit = jsonConvert.convert<
      ServiceOrderDetailEstateUnit>(json['estate_unit']);
  if (estateUnit != null) {
    serviceOrderDetailEntity.estateUnit = estateUnit;
  }
  return serviceOrderDetailEntity;
}

Map<String, dynamic> $ServiceOrderDetailEntityToJson(
    ServiceOrderDetailEntity entity) {
  final Map<String, dynamic> data = <String, dynamic>{};
  data['id'] = entity.id;
  data['sn'] = entity.sn;
  data['total_amount'] = entity.totalAmount;
  data['paid_at'] = entity.paidAt;
  data['notes'] = entity.notes;
  data['account'] = entity.account?.toJson();
  data['order_service'] = entity.orderService?.toJson();
  data['merchant'] = entity.merchant?.toJson();
  data['order_products'] =
      entity.orderProducts?.map((v) => v.toJson()).toList();
  data['estate'] = entity.estate?.toJson();
  data['estate_unit'] = entity.estateUnit?.toJson();
  return data;
}

extension ServiceOrderDetailEntityExtension on ServiceOrderDetailEntity {
  ServiceOrderDetailEntity copyWith({
    String? id,
    String? sn,
    String? totalAmount,
    String? paidAt,
    String? notes,
    ServiceOrderDetailAccount? account,
    ServiceOrderDetailOrderService? orderService,
    IdNameEntity? merchant,
    List<ServiceOrderDetailOrderProducts>? orderProducts,
    ServiceOrderDetailEstate? estate,
    ServiceOrderDetailEstateUnit? estateUnit,
  }) {
    return ServiceOrderDetailEntity()
      ..id = id ?? this.id
      ..sn = sn ?? this.sn
      ..totalAmount = totalAmount ?? this.totalAmount
      ..paidAt = paidAt ?? this.paidAt
      ..notes = notes ?? this.notes
      ..account = account ?? this.account
      ..orderService = orderService ?? this.orderService
      ..merchant = merchant ?? this.merchant
      ..orderProducts = orderProducts ?? this.orderProducts
      ..estate = estate ?? this.estate
      ..estateUnit = estateUnit ?? this.estateUnit;
  }
}

ServiceOrderDetailAccount $ServiceOrderDetailAccountFromJson(
    Map<String, dynamic> json) {
  final ServiceOrderDetailAccount serviceOrderDetailAccount = ServiceOrderDetailAccount();
  final String? id = jsonConvert.convert<String>(json['id']);
  if (id != null) {
    serviceOrderDetailAccount.id = id;
  }
  final String? name = jsonConvert.convert<String>(json['name']);
  if (name != null) {
    serviceOrderDetailAccount.name = name;
  }
  final String? avatar = jsonConvert.convert<String>(json['avatar']);
  if (avatar != null) {
    serviceOrderDetailAccount.avatar = avatar;
  }
  final String? phone = jsonConvert.convert<String>(json['phone']);
  if (phone != null) {
    serviceOrderDetailAccount.phone = phone;
  }
  return serviceOrderDetailAccount;
}

Map<String, dynamic> $ServiceOrderDetailAccountToJson(
    ServiceOrderDetailAccount entity) {
  final Map<String, dynamic> data = <String, dynamic>{};
  data['id'] = entity.id;
  data['name'] = entity.name;
  data['avatar'] = entity.avatar;
  data['phone'] = entity.phone;
  return data;
}

extension ServiceOrderDetailAccountExtension on ServiceOrderDetailAccount {
  ServiceOrderDetailAccount copyWith({
    String? id,
    String? name,
    String? avatar,
    String? phone,
  }) {
    return ServiceOrderDetailAccount()
      ..id = id ?? this.id
      ..name = name ?? this.name
      ..avatar = avatar ?? this.avatar
      ..phone = phone ?? this.phone;
  }
}

ServiceOrderDetailOrderService $ServiceOrderDetailOrderServiceFromJson(
    Map<String, dynamic> json) {
  final ServiceOrderDetailOrderService serviceOrderDetailOrderService = ServiceOrderDetailOrderService();
  final String? id = jsonConvert.convert<String>(json['id']);
  if (id != null) {
    serviceOrderDetailOrderService.id = id;
  }
  final String? name = jsonConvert.convert<String>(json['name']);
  if (name != null) {
    serviceOrderDetailOrderService.name = name;
  }
  final double? evaluationsAvgScore = jsonConvert.convert<double>(
      json['evaluations_avg_score']);
  if (evaluationsAvgScore != null) {
    serviceOrderDetailOrderService.evaluationsAvgScore = evaluationsAvgScore;
  }
  return serviceOrderDetailOrderService;
}

Map<String, dynamic> $ServiceOrderDetailOrderServiceToJson(
    ServiceOrderDetailOrderService entity) {
  final Map<String, dynamic> data = <String, dynamic>{};
  data['id'] = entity.id;
  data['name'] = entity.name;
  data['evaluations_avg_score'] = entity.evaluationsAvgScore;
  return data;
}

extension ServiceOrderDetailOrderServiceExtension on ServiceOrderDetailOrderService {
  ServiceOrderDetailOrderService copyWith({
    String? id,
    String? name,
    double? evaluationsAvgScore,
  }) {
    return ServiceOrderDetailOrderService()
      ..id = id ?? this.id
      ..name = name ?? this.name
      ..evaluationsAvgScore = evaluationsAvgScore ?? this.evaluationsAvgScore;
  }
}

ServiceOrderDetailOrderProducts $ServiceOrderDetailOrderProductsFromJson(
    Map<String, dynamic> json) {
  final ServiceOrderDetailOrderProducts serviceOrderDetailOrderProducts = ServiceOrderDetailOrderProducts();
  final String? id = jsonConvert.convert<String>(json['id']);
  if (id != null) {
    serviceOrderDetailOrderProducts.id = id;
  }
  final String? productName = jsonConvert.convert<String>(json['product_name']);
  if (productName != null) {
    serviceOrderDetailOrderProducts.productName = productName;
  }
  final String? productAmount = jsonConvert.convert<String>(
      json['product_amount']);
  if (productAmount != null) {
    serviceOrderDetailOrderProducts.productAmount = productAmount;
  }
  final String? urgentAmount = jsonConvert.convert<String>(
      json['urgent_amount']);
  if (urgentAmount != null) {
    serviceOrderDetailOrderProducts.urgentAmount = urgentAmount;
  }
  final String? holidayAmount = jsonConvert.convert<String>(
      json['holiday_amount']);
  if (holidayAmount != null) {
    serviceOrderDetailOrderProducts.holidayAmount = holidayAmount;
  }
  final String? nightAmount = jsonConvert.convert<String>(json['night_amount']);
  if (nightAmount != null) {
    serviceOrderDetailOrderProducts.nightAmount = nightAmount;
  }
  final int? quantity = jsonConvert.convert<int>(json['quantity']);
  if (quantity != null) {
    serviceOrderDetailOrderProducts.quantity = quantity;
  }
  final String? totalAmount = jsonConvert.convert<String>(json['total_amount']);
  if (totalAmount != null) {
    serviceOrderDetailOrderProducts.totalAmount = totalAmount;
  }
  final String? plannedServiceAt = jsonConvert.convert<String>(
      json['planned_service_at']);
  if (plannedServiceAt != null) {
    serviceOrderDetailOrderProducts.plannedServiceAt = plannedServiceAt;
  }
  return serviceOrderDetailOrderProducts;
}

Map<String, dynamic> $ServiceOrderDetailOrderProductsToJson(
    ServiceOrderDetailOrderProducts entity) {
  final Map<String, dynamic> data = <String, dynamic>{};
  data['id'] = entity.id;
  data['product_name'] = entity.productName;
  data['product_amount'] = entity.productAmount;
  data['urgent_amount'] = entity.urgentAmount;
  data['holiday_amount'] = entity.holidayAmount;
  data['night_amount'] = entity.nightAmount;
  data['quantity'] = entity.quantity;
  data['total_amount'] = entity.totalAmount;
  data['planned_service_at'] = entity.plannedServiceAt;
  return data;
}

extension ServiceOrderDetailOrderProductsExtension on ServiceOrderDetailOrderProducts {
  ServiceOrderDetailOrderProducts copyWith({
    String? id,
    String? productName,
    String? productAmount,
    String? urgentAmount,
    String? holidayAmount,
    String? nightAmount,
    int? quantity,
    String? totalAmount,
    String? plannedServiceAt,
  }) {
    return ServiceOrderDetailOrderProducts()
      ..id = id ?? this.id
      ..productName = productName ?? this.productName
      ..productAmount = productAmount ?? this.productAmount
      ..urgentAmount = urgentAmount ?? this.urgentAmount
      ..holidayAmount = holidayAmount ?? this.holidayAmount
      ..nightAmount = nightAmount ?? this.nightAmount
      ..quantity = quantity ?? this.quantity
      ..totalAmount = totalAmount ?? this.totalAmount
      ..plannedServiceAt = plannedServiceAt ?? this.plannedServiceAt;
  }
}

ServiceOrderDetailEstate $ServiceOrderDetailEstateFromJson(
    Map<String, dynamic> json) {
  final ServiceOrderDetailEstate serviceOrderDetailEstate = ServiceOrderDetailEstate();
  final String? id = jsonConvert.convert<String>(json['id']);
  if (id != null) {
    serviceOrderDetailEstate.id = id;
  }
  final String? name = jsonConvert.convert<String>(json['name']);
  if (name != null) {
    serviceOrderDetailEstate.name = name;
  }
  return serviceOrderDetailEstate;
}

Map<String, dynamic> $ServiceOrderDetailEstateToJson(
    ServiceOrderDetailEstate entity) {
  final Map<String, dynamic> data = <String, dynamic>{};
  data['id'] = entity.id;
  data['name'] = entity.name;
  return data;
}

extension ServiceOrderDetailEstateExtension on ServiceOrderDetailEstate {
  ServiceOrderDetailEstate copyWith({
    String? id,
    String? name,
  }) {
    return ServiceOrderDetailEstate()
      ..id = id ?? this.id
      ..name = name ?? this.name;
  }
}

ServiceOrderDetailEstateUnit $ServiceOrderDetailEstateUnitFromJson(
    Map<String, dynamic> json) {
  final ServiceOrderDetailEstateUnit serviceOrderDetailEstateUnit = ServiceOrderDetailEstateUnit();
  final String? id = jsonConvert.convert<String>(json['id']);
  if (id != null) {
    serviceOrderDetailEstateUnit.id = id;
  }
  final String? unit = jsonConvert.convert<String>(json['unit']);
  if (unit != null) {
    serviceOrderDetailEstateUnit.unit = unit;
  }
  final String? address = jsonConvert.convert<String>(json['address']);
  if (address != null) {
    serviceOrderDetailEstateUnit.address = address;
  }
  return serviceOrderDetailEstateUnit;
}

Map<String, dynamic> $ServiceOrderDetailEstateUnitToJson(
    ServiceOrderDetailEstateUnit entity) {
  final Map<String, dynamic> data = <String, dynamic>{};
  data['id'] = entity.id;
  data['unit'] = entity.unit;
  data['address'] = entity.address;
  return data;
}

extension ServiceOrderDetailEstateUnitExtension on ServiceOrderDetailEstateUnit {
  ServiceOrderDetailEstateUnit copyWith({
    String? id,
    String? unit,
    String? address,
  }) {
    return ServiceOrderDetailEstateUnit()
      ..id = id ?? this.id
      ..unit = unit ?? this.unit
      ..address = address ?? this.address;
  }
}